	.386
		.model flat,stdcall
		option casemap:none
		
include PALEDITTE.inc

include StingOps.asm
include ColorHandler.asm
include IniHandler.asm
include DiskHandler.asm
include PalletteControl.asm
;include TileEditor.asm
.code
		
start:
		__ GetModuleHandle,NULL
		mov hInstance,eax
		__ GetCommandLine
		__ InitCommonControls
		mov CommandLine,eax
		__ makeinistring
		__ GetPrivateProfileString,"Settings","SnesPath",0,lp SnesPath,$$ SnesPath,lp ininame
		__ OpenRom
		.if eax!=-1
			__ SaveRomFile
			.if eax!=-1
				__ WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
			.endif
		.endif
		
		__ ExitProcess,eax
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG
		
		mov wc.cbSize,sizeof WNDCLASSEX
		mov wc.style,CS_HREDRAW or CS_VREDRAW
		mov wc.lpfnWndProc,offset WndProc
		mov wc.cbClsExtra,NULL
		mov wc.cbWndExtra,DLGWINDOWEXTRA
		push hInst
		pop wc.hInstance
		mov wc.hbrBackground,COLOR_BTNFACE+1
		mov wc.lpszMenuName,IDM_MENU
		mov wc.lpszClassName,offset ClassName
		__ LoadIcon,hInstance,501
		mov wc.hIcon,eax
		mov wc.hIconSm,eax
		__ LoadCursor,NULL,IDC_ARROW
		mov wc.hCursor,eax
		__ RegisterClassEx,addr wc
		__ CreateDialogParam,hInstance,IDD_DIALOG,NULL,addr WndProc,NULL
		__ ShowWindow,hWnd,SW_SHOWNORMAL
		__ UpdateWindow,hWnd
		.while TRUE
			__ GetMessage,addr msg,NULL,0,0
			.BREAK .if !eax
			__ TranslateMessage,addr msg
			__ DispatchMessage,addr msg
		.endw
		mov eax,msg.wParam
		ret
		
WinMain endp
		
WndProc proc STDAPI hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL pt:POINT
LOCAL rect:RECT
LOCAL wipbuffer2[256]:BYTE
LOCAL wipbuffer3[256]:BYTE

LOCAL pr
		Switch uMsg
		Case WM_INITDIALOG
			m2m hWnd,hWin
			__ SendDlgItemMessage,hWin,1069,STM_SETIMAGE,IMAGE_BITMAP,_(LoadBitmap,hInstance,500)
			mov hList,rv( GetDlgItem,hWin,1099)
			__ SetWindowLong,hList,GWL_WNDPROC,ListProc
			mov lpListProc, eax
			
;			mov hTile,rv( GetDlgItem,hWin,1018)
;			__ SetWindowLong,hTile,GWL_WNDPROC,TileWinProc
;			mov lpTileWinProc, eax
			
			__ LoadPatchs,lp ininame
			__ GetDlgItem,hWin,1009
			mov hCtrl,eax
			invoke SetWindowLong,hCtrl,GWL_WNDPROC,CtrlProc
			mov lpCtrlProc, eax
			__ DrawPallettes,ScanPos
			__ SendDlgItemMessage,hWnd,1011, TBM_SETRANGEMAX,1,255
			__ SendDlgItemMessage,hWnd,1012, TBM_SETRANGEMAX,1,255
			__ SendDlgItemMessage,hWnd,1013, TBM_SETRANGEMAX,1,255
			mov ebx,rv(GetDlgItem,hWin,1070)
			__ SetWindowLong,ebx,GWL_WNDPROC,offset EditProc 
			__ SetWindowLong,ebx,GWL_USERDATA,eax
			
			mov ebx,rv(GetDlgItem,hWin,1071)
			__ SetWindowLong,ebx,GWL_WNDPROC,offset EditProc 
			__ SetWindowLong,ebx,GWL_USERDATA,eax
			
			mov ebx,rv(GetDlgItem,hWin,1072)
			__ SetWindowLong,ebx,GWL_WNDPROC,offset EditProc 
			__ SetWindowLong,ebx,GWL_USERDATA,eax
			__ SetTimer,hWin,5000,50,lp WndProc
		Case WM_HSCROLL
			__ GetDlgCtrlID,lParam
			.if eax==1011
				__ UpdateColorSlider,wParam,lParam,1070
			.elseif eax==1012
				__ UpdateColorSlider,wParam,lParam,1071
			.elseif eax==1013
				__ UpdateColorSlider,wParam,lParam,1072
			.endif
		Case WM_COMMAND
			.if _HIWORD(edx,wParam)== LBN_DBLCLK ;------------Lb selection change
				__ SendMessage,hList,LB_GETCURSEL,0,0
				__ SendMessage,hList,LB_GETTEXT,eax,lp wipbuffer
				__ GetPrivateProfileString,"Patch",lp wipbuffer,0,lp wipbuffer2,256,lp ininame
				__ SendDlgItemMessage,hWin,1008,WM_SETTEXT,0,lp wipbuffer2
				__ PostMessage,hWin,WM_COMMAND,1010,0
				return TRUE 
			.elseif edx==LBN_SELCHANGE ;------------Lb dbl change
				__ SendMessage,hList,LB_GETCURSEL,0,0
				__ SendMessage,hList,LB_GETTEXT,eax,lp wipbuffer
				__ GetPrivateProfileString,"Patch",lp wipbuffer,0,lp wipbuffer2,256,lp ininame
				__ SendDlgItemMessage,hWin,1008,WM_SETTEXT,0,lp wipbuffer2
				return TRUE 
			.endif
			
			Switch _LOWORD(eax,wParam) 
			
			Case 10004
					__ SendMessage,_(GetDlgItem,hWin,1008),WM_GETTEXT,256,lp wipbuffer
					__ CreateDialogParam,hInstance,8000,hWin,lp ADD_DialogProc,eax
			Case 10013
			__ SendMessage,hList,LB_GETCURSEL,0,0
					.if eax!=LB_ERR
						mov ebx,eax
						__ SendMessage,hList,LB_GETTEXT,eax,lp wipbuffer
						__ GetPrivateProfileString,"Patch",lp wipbuffer,0,lp wipbuffer3,256,lp ininame
						EDIT_DialogProc			PROTO	:HWND,:UINT,:WPARAM,:LPARAM
						__ CreateDialogParam,hInstance,8000,hWin,lp EDIT_DialogProc,eax
					.endif
			Case 10011
			__ SendMessage,hList,LB_GETCURSEL,0,0
					.if eax!=LB_ERR
						mov ebx,eax
						__ SendMessage,hList,LB_GETTEXT,eax,lp wipbuffer
						__ GetPrivateProfileString,"Patch",lp wipbuffer,0,lp wipbuffer3,256,lp ininame
						__ lstrcpy,lp wipbuffer2,"Name :"
						__ lstrcat,lp wipbuffer2,lp wipbuffer
						__ lstrcat,lp wipbuffer2,SADD(0dh,0ah)
						__ lstrcat,lp wipbuffer2,"Offset :"
						__ lstrcat,lp wipbuffer2,lp wipbuffer3
						__ MessageBox,hWin,lp wipbuffer2,lp RUSure,MB_ICONQUESTION+ MB_YESNO
						.if eax==IDYES
							__ WritePrivateProfileString,"Patch",lp wipbuffer,0,lp ininame
							__ SendMessage,hList,LB_DELETESTRING,ebx,0
						.endif
					.else
						return 0
					.endif
			Case 1014
				__ wsprintf,lp wipbuffer2,SADD("%08lX"),rv(getcurrentoffset)
				__ SetDlgItemText,hWnd,1008,lp wipbuffer2
			Case 10101
				__ MessageBox,hWnd,"Developed by Rixsta and PhatC in 2005","Paleditte v1.6 - Snes Rom Pallette Editor",MB_OK+ MB_ICONINFORMATION
			Case 10002
			
			__ lstrcpy,lp wipbuffer,"Source Rom Filename: "
			__ lstrcat,lp wipbuffer,lp RomFilename
			__ lstrcat,lp wipbuffer,SADD(0dh,0ah)
			
			__ lstrcat,lp wipbuffer,"Save Rom Filename: "
			__ lstrcat,lp wipbuffer,lp RomSaveFilename
			__ lstrcat,lp wipbuffer,SADD(0dh,0ah)
			
			__ lstrcat,lp wipbuffer,SADD(0dh,0ah)
			__ lstrcat,lp wipbuffer,"Snes Emulator: "
			__ lstrcat,lp wipbuffer,lp SnesPath
			__ MessageBox,hWnd,lp wipbuffer,"Filename Info",MB_OK+ MB_ICONINFORMATION
			Case 10006
				__ getcurrentoffset
				mov esi,eax
				mov edi,eax
				add esi,hUndoFile
				add edi,hRomFile
				mov ax,[esi]
				mov [edi],ax
				__ DrawPallettes,ScanPos
			Case 10007
				mov eax,ScanPos
				mov esi,eax
				mov edi,eax
				add esi,hUndoFile
				add edi,hRomFile
				mov ecx,32
				@@:
				mov ax,[esi]
				mov [edi],ax
				add esi,2
				add edi,2
				loop @b
				__ DrawPallettes,ScanPos
			Case 10008
				jmp reloadFile
			Case 10010
				__ MessageBox,hWin,SADD("Update Undo Buffer?"),"Buffer Update",MB_OKCANCEL + MB_ICONQUESTION
				.if eax==IDYES
					__ RtlMoveMemory,hUndoFile,hRomFile,Romsize
				.endif
			Case 1016
				mov TrackCursor,_(IsDlgButtonChecked,hWin,1016) 
			Case 1897
				mov ScanPos,0
				jmp @f
			Case 1898;<---------------------------------------------------------------------------------------------------------
				@@:
				__ GetEditRGB
				.if eax!=-1
					add _C(ScanPos),32
					__ FindRGBin16,ecx,eax
					.if eax!=-1
						;mov SearchStart,eax
						sub eax,32
						mov ScanPos,eax
						__ UpdateInfo
						__ DrawPallettes,ScanPos
					.else
						mov ScanPos,0
					.endif
				.endif
			Case 10009
				mov pr,0
				@@:
				mov rect.left,0
				mov rect.top,0
				mov rect.bottom,1
				mov eax,SelectedColor
				.if eax > oldColor
					sub eax,oldColor
					mov rect.right,eax
					; inc _A(oldColor)
					; inc eax
					mov edi,[COLORTABLE+4][ _A(oldColor)*4]
					mov esi,[COLORTABLE+4][_A(SelectedColor)*4]
					m2m GradStartColor,oldColor
					dec GradStartColor
					inc _C(rect.right)
					dec ecx
					__ GradFill,0,lp rect,edi,esi,ecx
					__ DrawPallettes,ScanPos 
				.elseif eax < oldColor
					push oldColor
					push SelectedColor
					pop oldColor
					pop SelectedColor
					mov pr,1
					jmp @b
				.endif			
				.if pr
					push oldColor
					push SelectedColor
					pop oldColor
					pop SelectedColor
				.endif	
			Case 1017
				OpenRom PROTO
				__ OpenRom
			Case 1018  
				__ SaveRomFile
			Case 2567
			__ SAVE,lp RomSaveFilename,hRomFile,Romsize
			__ MessageBox,hWnd,lp RomSaveFilename,"Saved",MB_ICONINFORMATION + MB_OK 
			Case IDM_FILE_EXIT
				__ SendMessage,hWin,WM_CLOSE,0,0
			Case 2101 ;Dump and test
			GetPathOnly				PROTO	:DWORD,:DWORD
				__ SAVE,lp RomSaveFilename,hRomFile ,Romsize
				__ GetPathOnly,lp RomSaveFilename,lp wipbuffer
				__ SetCurrentDirectory,lp wipbuffer
				__ ShellExecute,0,"open",lp SnesPath,lp RomSaveFilename,lp wipbuffer,SW_SHOWDEFAULT
			Case 10003
			reloadFile: 	__ ReloadRom
			Case 1068
				mov PalleteSelected,rv(ColorDialog,hWin,hInstance,CC_FULLOPEN)
				__ UpdateRGBControls,PalleteSelected
			Case 1077
				m2m PalleteBackup,PalleteSelected
				__ InvalidateRect,_(GetDlgItem,hWin,1078),0,TRUE
			Case 1079
				__ UpdateRGBControls,PalleteBackup
			Case 1001
			mover:	add ScanPos,2*8
				__ DrawPallettes,ScanPos 
			Case 1002
			movel:	sub ScanPos,2*8
				__ DrawPallettes,ScanPos 
			Case 1004
				add ScanPos,-2
				__ DrawPallettes,ScanPos
			Case 1005
				add ScanPos,2
				__ DrawPallettes,ScanPos
			Case 1010 ;jump to offset
				__ GetDlgItemText,hWin,1008,lp wipbuffer,9
				lea ebx,wipbuffer
				.if [wipbuffer][0]=='$' ;Snes Pal suport ;-P
					inc ebx
				.endif
				__ a2dw,ebx
				mov ScanPos,eax
				__ DrawPallettes,ScanPos
				call UpdateInfo
				__ InvalidateRect,hWin,0,TRUE
	;		Case 1022
	;			add TileOffset,4
	;			__ InvalidateRect,_(GetDlgItem,hWnd,1018),0,TRUE
	;			__ SetDlgItemInt,hWin,1021,biWidth,TRUE 
	;		Case 1023
	;			add TileOffset,-4
	;		__ InvalidateRect,_(GetDlgItem,hWnd,1018),0,TRUE
	;		__ SetDlgItemInt,hWin,1021,biWidth,TRUE 
	;		
	;		Case 1019
	;			inc biWidth
	;			__ InvalidateRect,_(GetDlgItem,hWnd,1018),0,TRUE
	;			__ SetDlgItemInt,hWin,1021,biWidth,TRUE 
	;		Case 1020
	;		dec biWidth
	;		__ InvalidateRect,_(GetDlgItem,hWnd,1018),0,TRUE
	;		__ SetDlgItemInt,hWin,1021,biWidth,TRUE 
			
			
			Case 1007
				__ Apply32,_(getcurrentoffset),PalleteSelected
				__ DrawPallettes,ScanPos
			Case 1003
				__ GetDlgItemInt,hWin,1070,lp crap,TRUE
				.if eax>7
					sub eax,8
				.else
					mov eax,0
				.endif
				__ SetDlgItemInt,hWin,1070,eax,TRUE
				
				__ GetDlgItemInt,hWin,1071,lp crap,TRUE
				.if eax>7
					sub eax,8
				.else
					mov eax,0
				.endif
				__ SetDlgItemInt,hWin,1071,eax,TRUE
				__ GetDlgItemInt,hWin,1072,lp crap,TRUE
				.if eax>7
					sub eax,8
				.else
					mov eax,0
				.endif
				__ SetDlgItemInt,hWin,1072,eax,TRUE
				__ UpdateFromEdit
			Case 1015
				__ GetDlgItemInt,hWin,1070,lp crap,TRUE
				.if eax<(255-8)
					add eax,8
				.else
					mov eax,255
				.endif
				__ SetDlgItemInt,hWin,1070,eax,TRUE
				
				__ GetDlgItemInt,hWin,1071,lp crap,TRUE
				.if eax<(255-8)
					add eax,8
				.else
					mov eax,255
				.endif
				__ SetDlgItemInt,hWin,1071,eax,TRUE
				
				__ GetDlgItemInt,hWin,1072,lp crap,TRUE
				.if eax<(255-8)
					add eax,8
				.else
					mov eax,255
				.endif
				__ SetDlgItemInt,hWin,1072,eax,TRUE
				__ UpdateFromEdit
			Endsw
		Case WM_CTLCOLORSTATIC
			mov ebx ,rv( GetDlgCtrlID,lParam)
			.if ebx==1076
				.If hBrush
				__ DeleteObject, hBrush
				.EndIf
				__ SetBkColor, wParam, 0
				__ SetTextColor, wParam,0
				__ CreateSolidBrush,PalleteSelected
				Ret
			.endif
			.if ebx==1078
				.If hBrush
				__ DeleteObject, hBrush
				.EndIf
				__ SetBkColor, wParam, 0
				__ SetTextColor, wParam,0
				__ CreateSolidBrush,PalleteBackup
				Ret
			.endif
			__ SetBkColor,wParam,_(GetSysColor,COLOR_BTNFACE)
			__ GetSysColorBrush,COLOR_BTNFACE
			Ret
		Case WM_LBUTTONDOWN 
			__ SetCapture,hWin
			mov mPressed,TRUE
			@@:
			mov pt.x,_LOWORD(eax,lParam); 
			mov pt.y,_HIWORD(eax,lParam); 
			.if ( pt.x > 276 && pt.x < 596) && ( pt.y > 1 && pt.y< 122)
				mov ebx,_(GetDlgItem,hWin,1069)
				__ ClientToScreen,hWin,lp pt
				__ ScreenToClient,ebx,lp pt
				__ GetDC,ebx
				mov esi,eax
				__ GetPixel,eax,pt.x,pt.y
				mov edi,eax
				__ ReleaseDC,ebx,esi
				__ UpdateRGBControls,edi
				__ SetFocus,ebx
			.endif
		Case WM_MOUSEMOVE
			.if mPressed==TRUE
				jmp @b 
			.endif
		Case WM_LBUTTONUP
			mov mPressed,NULL 
			__ ReleaseCapture
			STARX= 60
			STARY= 40
			.if _HIWORD(eax,lParam) > 228 && eax <228+STARY
				mov eax, _LOWORD(eax,lParam)
				sub eax,STARX
				mov edx, 3435973837
				mul edx
				SHR edx, 4
				m2m oldColor,SelectedColor
				mov SelectedColor,edx
				__ InvalidateRect,_(GetDlgItem,hWin,1009),0,TRUE
				call getcurrentoffset
				__ Convert16to32,eax
				__ UpdateRGBControls,eax
				call UpdateInfo
				__ SetFocus,_(GetDlgItem,hWin,1009)
			.endif
		Case WM_RBUTTONUP
			.if _HIWORD(eax,lParam) > 228 && eax <228+40
				;__ SendMessage,hWin,WM_LBUTTONDOWN,wParam,lParam
				;__ SendMessage,hWin,WM_LBUTTONUP,wParam,lParam
				__ SetForegroundWindow,hWin
				__ GetCursorPos,addr pt 
				__ GetSubMenu,_(GetMenu,hWin),1
				__ TrackPopupMenu,eax,TPM_LEFTALIGN,pt.x,pt.y,NULL,hWin,NULL 
				__ PostMessage,hWin,WM_NULL,0,0
			.endif
		Case 020ch
				Switch _HIWORD(eax,wParam)
				Case 0001
					add ScanPos,-2
					__ DrawPallettes,ScanPos
				Case 0002
					add ScanPos,2
					__ DrawPallettes,ScanPos
				Endsw
		case WM_MOUSEWHEEL 
				mov edx, wParam 
				sar edx, 16 
				.if( SDWORD PTR edx > 0) 				;  "Move Positive Wheel (Wheel UP)" 
					shr edx, 3 
					neg edx 
					and edx, 0fh 
					shl edx,1
					add ScanPos,edx
					__ DrawPallettes,ScanPos
				.else 				;  "Move Negative Wheel (Wheel DOwn)" 
					shr edx, 3
					and edx, 0fh
					shl edx,1
					sub ScanPos,edx
					__ DrawPallettes,ScanPos
				.endif
		Case WM_TIMER
			__ GetCursorPos,lp pt
			__ GetDC,0
			mov ebx,eax
			__ GetPixel,eax,pt.x,pt.y
			mov edi,eax
			__ ReleaseDC,0,ebx
			mov eax,edi
			mov ebx,eax
			mov ecx,32
			mov edi,offset COLORTABLE+4
			@@:
			.if eax==[edi]
				neg ecx
				add ecx,32
				.if ecx!=PointColor
					mov PointColor,ecx
					__ DrawPallettes,ScanPos
				.endif
			.else
				add edi,4
				dec ecx
				jnz @b
			.endif
			__ GetAsyncKeyState,VK_LCONTROL
			and eax,1
			.if eax==TRUE
				__ UpdateRGBControls,ebx		
			.endif
		Case WM_USER+1
			__ SendMessage,hList,LB_RESETCONTENT,0,0
			__ LoadPatchs,lp ininame
		Case WM_CLOSE
			__ GlobalFree,hUndoFile
			__ GlobalFree,hRomFile
			__ DestroyWindow,hWin
		Case WM_DESTROY
			__ KillTimer,hWnd,5000
			__ PostQuitMessage,NULL
		.else
			__ DefWindowProc,hWin,uMsg,wParam,lParam
			ret
		Endsw
		return FALSE
WndProc endp


end start 
