Capitalize				PROTO	:DWORD
ltrim					PROTO	:DWORD,:DWORD
rtrim					PROTO	:DWORD,:DWORD

.code
Capitalize proc text:DWORD
		pushad
		mov edx, text
		lcSt:
		mov al, [edx] ; load byte into al
		cmp al, "A"
		jb @F ; jump if less than ascii "A"
		cmp al, "Z"
		ja @F ; jump if greater than ascii "Z"
		add al, 32 ; else if uppercase, add 32 to make lowercase
		@@:
		mov [edx], al ; write byte to address in edx
		inc edx
		cmp al, 0 ; exit on zero terminator
		jne lcSt
		
		
		mov edx, text
		ucSt:
		mov al, [edx] ; load byte into al
		.if (al>'a'-1 && al<'z'+1)
			sub al, 32 ; sub 32 to make uppercase
			mov [edx], al 
		.endif 
		
		@@:
		inc edx
		mov al, [edx]
		.if al==20h; || al=='\' ;|| al == '_' ; || al=='.'
			mov cl, [edx+1]
			.if cl !=0 
				.if (cl>'a'-1 && cl<'z'+1)
					sub cl, 32
					mov [edx+1],cl
					jmp @b
				.endif 
			.endif 
			jmp @b
			
		.elseif al==0
			JMP @f
		.endif
		jmp @b
		@@:
		popad
		ret
Capitalize endp
		
rtrim proc source:DWORD,dest:DWORD
		
		push esi
		push edi
		
		mov esi, source
		xor ecx, ecx ; zero ecx to use as counter
		
		@@:
		mov al, [esi]
		inc esi
		inc ecx ; get string length excluding zero
		cmp al, 0 ; exit loop on zero
		jne @B
		
		lea esi, [esi-2] ; correct esi count
		
		@@:
		mov al, [esi]
		dec esi
		dec ecx
		cmp al, 32 ; loop if space
		je @B
		cmp al, 9 ; loop if tab
		je @B
		
		cld ; read forward
		
		inc ecx
		mov esi, source
		mov edi, dest
		rep movsb
		
		mov [edi-1], byte ptr 0
		
		pop edi
		pop esi
		
		ret
		
rtrim endp
		
ltrim proc source:DWORD,dest:DWORD
		
		push esi
		push edi
		
		mov esi, source
		mov edi, dest
		
		cld ; read forward
		
		@@:
		lodsb
		cmp al, 0 ; exit on zero
		je ltOut_Label
		cmp al, 32 ; loop if space
		je @B
		cmp al, 9 ; loop if tab
		je @B
		stosb
		
		@@:
		lodsb
		cmp al, 0 ; exit on zero
		je ltOut_Label
		stosb
		jmp @B
		
		ltOut_Label:
		stosb ; write terminating zero
		
		pop edi
		pop esi
		ret
ltrim endp