.code
Apply32 PROTO :DWORD,:DWORD
ColorDialog PROTO :DWORD,:DWORD,:DWORD
Convert16to32 PROTO :DWORD
Convert32to16 PROTO :DWORD
FindRGBin16 PROTO :DWORD,:DWORD
DrawPallettes PROTO :DWORD
		
DrawPallettes proc STDAPI currentoffset
		
		mov ebx,32
		dec currentoffset
		dec currentoffset
		add currentoffset,32*2
		
		.while ebx
Convert16to32 PROTO :DWORD
			__ Convert16to32,currentoffset
			mov edi,eax
			mov [COLORTABLE][ebx*4],eax
			dec currentoffset
			dec currentoffset
			dec ebx
		.endw
		__ InvalidateRect,_(GetDlgItem,hWnd,1009),0,TRUE
		__ InvalidateRect,_(GetDlgItem,hWnd,1018),0,TRUE
		Call UpdateInfo
		ret
DrawPallettes endp
UpdateRGBControls proc dwColor:DWORD
		m2m PalleteSelected,dwColor
		__ InvalidateRect,_(GetDlgItem,hWnd,1076),0,TRUE
		and _A(dwColor),0ffh
		mov ebx,eax
		__ SetDlgItemInt,hWnd,1070,eax,NULL
		__ SendDlgItemMessage,hWnd,1011,TBM_SETPOS,1,ebx
		
		shr _A(dwColor),8
		and eax,0ffh
		mov ebx,eax
		__ SetDlgItemInt,hWnd,1071,eax,NULL
		__ SendDlgItemMessage,hWnd,1012,TBM_SETPOS,1,ebx
		
		shr _A(dwColor),16
		and eax,0ffh
		mov ebx,eax
		__ SetDlgItemInt,hWnd,1072,eax,NULL
		__ SendDlgItemMessage,hWnd,1013,TBM_SETPOS,1,ebx
		ret
UpdateRGBControls endp
ColorDialog proc uses edi hWin:DWORD, instance:DWORD, Flags:DWORD
		
LOCAL ccl:CHOOSECOLOR
LOCAL crv[16]:DWORD
		
		lea edi, crv[0]
		mov ecx, 16
		mov eax, 0FFFFFFh
		rep stosd
		
		mov ccl.lStructSize, sizeof CHOOSECOLOR
		push hWin
		pop ccl.hwndOwner 
		push instance
		pop ccl.hInstance
		mov ccl.rgbResult, 0
		lea eax, crv ; address of 16 item DWORD array
		mov ccl.lpCustColors, eax
		push Flags
		pop ccl.Flags
		mov ccl.lCustData, 0
		mov ccl.lpfnHook, 0
		mov ccl.lpTemplateName, 0
		
		__ ChooseColor,lp ccl
		
		.if eax != 0
			mov eax, ccl.rgbResult
			mov edi, 1
		.else
			xor edi, edi
		.endif
		ret
ColorDialog endp
		
Convert16to32 proc STDAPI fileoffset
		
		.if Romsize<_C(fileoffset)
			return -1
		.endif
		
		mov eax,hRomFile
		add eax,fileoffset
		xor ecx,ecx
		
		mov cx,[eax]
		mov eax,ecx
		mov edx,ecx
		
		and eax,011111b
		shl eax,3 ; rgb color adjustment!
		
		shr ecx,5
		and ecx,011111b
		shl ecx,3 ; rgb color adjustment!
		
		shr edx,5+5
		and edx,011111b
		shl edx,3 ; rgb color adjustment!
		
		wipe ebx
		
		Mov bl , dl 
		Shl ebx , 16
		Mov bh , cl 
		Mov bl , al
		mov eax,ebx
		
		; 
		ret
		
Convert16to32 endp
FindRGBin16 proc STDAPI startoff,dwcolor
		
		__ Convert32to16,dwcolor
		mov edx,eax
		mov esi,hRomFile
		add esi,Romsize
		dec esi
		dec esi
		dec esi
		dec esi
		;xchg dl,dh
		inc startoff
		inc startoff
		mov ecx,Romsize
		sub ecx,startoff
		
		mov edi,hRomFile
		add edi,startoff
		and edi,not 1
		@@:
		.if edi <esi 
			mov ax,[edi]
			.if dx==ax
				sub edi,hRomFile
				and edi,not 1
				mov eax,edi
				ret
			.else
				inc edi
				inc edi
				dec ecx
				dec ecx
				jnz @b
			.endif
			
		.endif
		mov eax,-1
		ret
		
FindRGBin16 endp
Convert32to16 proc STDAPI dwcolor
		
		mov eax,dwcolor
		mov ecx,dwcolor
		mov edx,dwcolor
		
		and eax,0ffh
		shr eax,3 
		
		shr ecx,8
		and ecx,0ffh
		shr ecx,3
		
		shr edx,16
		and edx,0ffh
		shr edx,3
		
		
		; color adjustment
		
		wipe ebx
		shl ecx,5
		shl edx,5+5
		
		or ebx,eax
		or ebx,ecx
		or ebx,edx
		
		mov eax,ebx
		
		; 
		ret
		
Convert32to16 endp
Apply32 proc STDAPI fileoffset,dwcolor
		
		.if Romsize<_C(fileoffset)
			return -1
		.endif
		
		;and esi,(not 1)
		mov eax,dwcolor
		mov ecx,dwcolor
		mov edx,dwcolor
		
		and eax,0ffh
		shr eax,3 
		
		shr ecx,8
		and ecx,0ffh
		shr ecx,3
		
		shr edx,16
		and edx,0ffh
		shr edx,3
		
		
		; color adjustment
		
		wipe ebx
		shl ecx,5
		shl edx,5+5
		
		or ebx,eax
		or ebx,ecx
		or ebx,edx
		
		mov eax,fileoffset
		add eax,hRomFile
		mov [eax],bx
		; 
		ret
Apply32 endp 
